unit MJMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ExtCtrls, Menus, ToolWin, ImgList, StdCtrls, JPEG;

const CopyrightLine='MJ2000 SR1  2000 Martin J. Fiedler';
      ProgramInfoLine='MJ2000 SR1 (12.12.2000)';

type
  TMainForm = class(TForm)
    Status: TStatusBar;
    Menu: TMainMenu;
    MFile: TMenuItem;
    MHelp: TMenuItem;
    MGame: TMenuItem;
    MExit: TMenuItem;
    MHint: TMenuItem;
    MAbout: TMenuItem;
    ToolBar: TToolBar;
    BNew: TToolButton;
    Bevel1: TBevel;
    TimerObject: TTimer;
    BHint: TToolButton;
    Separator2: TToolButton;
    BUndo: TToolButton;
    BRedo: TToolButton;
    MNew: TMenuItem;
    Symbols: TImageList;
    MUndo: TMenuItem;
    MRedo: TMenuItem;
    Separator1: TToolButton;
    BLoad: TToolButton;
    BSave: TToolButton;
    MLoad: TMenuItem;
    MSave: TMenuItem;
    MSaveAs: TMenuItem;
    SaveRequester: TSaveDialog;
    OpenRequester: TOpenDialog;
    Separator3: TToolButton;
    BPause: TToolButton;
    MPause: TMenuItem;
    MOptions: TMenuItem;
    MFormat: TMenuItem;
    MFDevice: TMenuItem;
    MF32: TMenuItem;
    MF24: TMenuItem;
    MF16: TMenuItem;
    MF15: TMenuItem;
    MF8: TMenuItem;
    MF4: TMenuItem;
    MShowSpeed: TMenuItem;
    MScore: TMenuItem;
    MHelpStart: TMenuItem;
    Separator4: TToolButton;
    BHelp: TToolButton;
    MNoUnsolveableGames: TMenuItem;
    MForceRepaint: TMenuItem;
    N1: TMenuItem;
    Field: TPaintBox;
    procedure MExitClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MHintClick(Sender: TObject);
    procedure BNewClick(Sender: TObject);
    procedure FieldMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FieldMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TimerObjectTimer(Sender: TObject);
    procedure BHintClick(Sender: TObject);
    procedure MNewClick(Sender: TObject);
    procedure BUndoClick(Sender: TObject);
    procedure BRedoClick(Sender: TObject);
    procedure MUndoClick(Sender: TObject);
    procedure MRedoClick(Sender: TObject);
    procedure BSaveClick(Sender: TObject);
    procedure BLoadClick(Sender: TObject);
    procedure MSaveClick(Sender: TObject);
    procedure MLoadClick(Sender: TObject);
    procedure MSaveAsClick(Sender: TObject);
    procedure MAboutClick(Sender: TObject);
    procedure BPauseClick(Sender: TObject);
    procedure MPauseClick(Sender: TObject);
    procedure MFDeviceClick(Sender: TObject);
    procedure MF32Click(Sender: TObject);
    procedure MF24Click(Sender: TObject);
    procedure MF16Click(Sender: TObject);
    procedure MF15Click(Sender: TObject);
    procedure MF8Click(Sender: TObject);
    procedure MF4Click(Sender: TObject);
    procedure MShowSpeedClick(Sender: TObject);
    procedure MScoreClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure MHelpStartClick(Sender: TObject);
    procedure BHelpClick(Sender: TObject);
    procedure MNoUnsolveableGamesClick(Sender: TObject);
    procedure MForceRepaintClick(Sender: TObject);
    procedure FieldPaint(Sender: TObject);
  private
    { Private-Deklarationen}
  public
    { Public-Deklarationen}
  end;

var
  MainForm: TMainForm;
  Timer:integer;

implementation
uses MJCore, MJScore;

{$R *.DFM}

procedure TMainForm.MExitClick(Sender: TObject);
begin
  QuitProgram;
  Close;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Timer:=GetTickCount;
  varint;
  PauseGame;
  PWrite($FFFFFF,'Start mit Mausklick');
  PWrite($FFFFFF,'');
  PWrite($C0B4A0,ProgramInfoLine);
end;

procedure TMainForm.MHintClick(Sender: TObject);
begin
  if Game AND not(Won) then MJCore.Hint;
end;

procedure TMainForm.BNewClick(Sender: TObject);
begin
  NewGame;MoveCheck;Redraw;
end;

procedure TMainForm.FieldMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var Tile:integer;
begin
  if Won OR not(Game) then Exit;
  Tile:=FindTile(x,y);
  if Tile>0 then begin
    Enlightenment(TilePos(Tile));
    Flip;
  end;
end;

procedure TMainForm.FieldMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var Tile:integer;
begin
  if Game then begin
    if Won then exit;
    Tile:=FindTile(x,y);
    if Tile>0 then UseTile(Tile);
    if MJCore.Changed then MoveCheck;
    Redraw;
    MJCore.Changed:=False;
  end else
    ContinueGame;
end;

procedure TMainForm.TimerObjectTimer(Sender: TObject);
begin
  Timer:=GetTickCount;
  TimerHandler;
end;

procedure TMainForm.BHintClick(Sender: TObject);
begin
  if Game AND not(Won) then MJCore.Hint;
end;

procedure TMainForm.MNewClick(Sender: TObject);
begin
  NewGame;MoveCheck;Redraw;
end;

procedure TMainForm.BUndoClick(Sender: TObject);
begin
  if Game AND not(Won) then MJCore.Undo;
end;

procedure TMainForm.BRedoClick(Sender: TObject);
begin
  if Game AND not(Won) then MJCore.Redo;
end;

procedure TMainForm.MUndoClick(Sender: TObject);
begin
  if Game AND not(Won) then MJCore.Undo;
end;

procedure TMainForm.MRedoClick(Sender: TObject);
begin
  if Game AND not(Won) then MJCore.Redo;
end;

procedure TMainForm.BSaveClick(Sender: TObject);
begin
  if not(Won) then SaveGame;
end;

procedure TMainForm.BLoadClick(Sender: TObject);
begin
  LoadGame;
end;

procedure TMainForm.MSaveClick(Sender: TObject);
begin
  if not(Won) then SaveGame;
end;

procedure TMainForm.MLoadClick(Sender: TObject);
begin
  OpenRequester.FileName:=SGFileName;
  if OpenRequester.Execute then begin
    SGFileName:=OpenRequester.FileName;
    LoadGame;
  end;
end;

procedure TMainForm.MSaveAsClick(Sender: TObject);
begin
  if Won then exit;
  SaveRequester.FileName:=SGFileName;
  if SaveRequester.Execute then begin
    SGFileName:=SaveRequester.FileName;
    SaveGame;
  end;
end;

procedure TMainForm.MAboutClick(Sender: TObject);
begin
  PauseGame;
  PWrite($00FFFFFF,'geschrieben in Borland Delphi 4.0');
  PWrite($00FFFFFF,'');
  PWrite($00FFFFFF,'E-Mail: <martin.fiedler@gmx.net>');
  PWrite($00FFFFFF,CopyrightLine);
end;

procedure TMainForm.BPauseClick(Sender: TObject);
begin
  if Game then begin
    PauseGame;
    PWrite($00FFFFFF,'weiter mit Mausklick');
    PWrite($00FFFFFF,'PAUSE-MODUS');
  end else
    ContinueGame;
end;

procedure TMainForm.MPauseClick(Sender: TObject);
begin
  BPauseClick(Sender);
end;

procedure TMainForm.MFDeviceClick(Sender: TObject);
begin
  MFDevice.Checked:=True;
  PixForm:=pfDevice;
  InitSprites;
  if Game then Redraw;
end;

procedure TMainForm.MF32Click(Sender: TObject);
begin
  MF32.Checked:=True;
  PixForm:=pf32bit;
  InitSprites;
  if Game then Redraw;
end;

procedure TMainForm.MF24Click(Sender: TObject);
begin
  MF24.Checked:=True;
  PixForm:=pf24bit;
  InitSprites;
  if Game then Redraw;
end;

procedure TMainForm.MF16Click(Sender: TObject);
begin
  MF16.Checked:=True;
  PixForm:=pf16bit;
  InitSprites;
  if Game then Redraw;
end;

procedure TMainForm.MF15Click(Sender: TObject);
begin
  MF15.Checked:=True;
  PixForm:=pf15bit;
  InitSprites;        
  if Game then Redraw;
end;

procedure TMainForm.MF8Click(Sender: TObject);
begin
  MF8.Checked:=True;
  PixForm:=pf8bit;
  InitSprites;        
  if Game then Redraw;
end;

procedure TMainForm.MF4Click(Sender: TObject);
begin
  MF4.Checked:=True;
  PixForm:=pf4bit;
  InitSprites;        
  if Game then Redraw;
end;

procedure TMainForm.MShowSpeedClick(Sender: TObject);
begin
  ShowRenderSpeed:=not(ShowRenderSpeed);
  MShowSpeed.Checked:=ShowRenderSpeed;
end;

procedure TMainForm.MScoreClick(Sender: TObject);
begin
  ScoreForm.ShowOnly;
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  QuitProgram;
  CanClose:=True;
end;

procedure TMainForm.MHelpStartClick(Sender: TObject);
begin
  RunHelp;
end;

procedure TMainForm.BHelpClick(Sender: TObject);
begin
  RunHelp;
end;

procedure TMainForm.MNoUnsolveableGamesClick(Sender: TObject);
begin
  AvoidUnsolveableGames:=not(AvoidUnsolveableGames);
  MNoUnsolveableGames.Checked:=AvoidUnsolveableGames;
end;

procedure TMainForm.MForceRepaintClick(Sender: TObject);
begin
  ForceRepaint:=not(ForceRepaint);
  MForceRepaint.Checked:=ForceRepaint;
end;

procedure TMainForm.FieldPaint(Sender: TObject);
begin
  Field.Canvas.Draw(0,0,Buf);
end;

end.
