unit MJScore;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, Grids;

type
  TScoreForm = class(TForm)
    OKbtn: TBitBtn;
    ScoreBox: TStringGrid;
    ScoreInpPanel: TPanel;
    LDummy: TLabel;
    LGrat: TLabel;
    LPrompt: TLabel;
    InpName: TEdit;
    procedure OKbtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure InpNameChange(Sender: TObject);
  private
    ChangeMode:boolean;
    procedure RedrawAll;
    procedure SelectLine(no:integer);
  public
    procedure ShowOnly;
    procedure Execute(GTime:integer);
  end;

type TScore=record
              Name:string[20];
              Time:integer;
              Date:TDateTime;
            end;
     TScoreArray=array[0..10]of TScore;
const Scores:TScoreArray=((Name:'';Time:0;Date:0),
                          (Name:'MJ2000';Time:180000;Date:36526.5),
                          (Name:'MJ2000';Time:240000;Date:36526.5),
                          (Name:'MJ2000';Time:300000;Date:36526.5),
                          (Name:'MJ2000';Time:360000;Date:36526.5),
                          (Name:'MJ2000';Time:420000;Date:36526.5),
                          (Name:'MJ2000';Time:480000;Date:36526.5),
                          (Name:'MJ2000';Time:540000;Date:36526.5),
                          (Name:'MJ2000';Time:600000;Date:36526.5),
                          (Name:'MJ2000';Time:660000;Date:36526.5),
                          (Name:'MJ2000';Time:720000;Date:36526.5));
var ActiveNo:integer;
procedure FindScore(FTime:integer);
procedure InsertScore(No:integer);

var
  ScoreForm: TScoreForm;

implementation
uses MJCore;

{$R *.DFM}

procedure FindScore(FTime:integer);
begin
  ActiveNo:=11;
  while FTime<Scores[ActiveNo-1].Time do dec(ActiveNo);
  if ActiveNo=11 then ActiveNo:=0;
end;

procedure InsertScore(No:integer);
var i:integer;
begin
  if (No<1) OR (No>9) then exit;
  for i:=9 downto No do
    Scores[i+1]:=Scores[i];
  Scores[No]:=Scores[0];
end;

procedure TScoreForm.RedrawAll;
var no:integer;Score:TScore;TimeSec,Min,Sec:integer;Str1,Str2:string[2];
    DYear,DMonth,DDay:word;
begin
  for no:=1 to 10 do begin
    Score:=Scores[no];
    ScoreBox.Cells[1,no]:=Score.Name;
    TimeSec:=Score.Time DIV 1000;
      Min:=TimeSec DIV 60;
      Sec:=TimeSec MOD 60;
      Str1:=char(Sec DIV 10+48)+char(Sec MOD 10+48);
      Str2:=char(Min DIV 10+48)+char(Min MOD 10+48);
      ScoreBox.Cells[2,no]:=Str2+':'+Str1;
    DecodeDate(Score.Date,DYear,DMonth,DDay);
      Str1:=char(DDay DIV 10+48)+char(DDay MOD 10+48);
      Str2:=char(DMonth DIV 10+48)+char(DMonth MOD 10+48);
      ScoreBox.Cells[3,no]:=Str1+'.'+Str2+'.'+IntToStr(DYear);
  end;
end;

procedure TScoreForm.SelectLine(no:integer);
var Area:TGridRect;
begin
  with Area do begin
    Left:=0;Right:=3;
    Top:=no;Bottom:=no;
  end;
  ScoreBox.Selection:=Area;
end;

procedure TScoreForm.ShowOnly;
begin
  ChangeMode:=False;
  LGrat.Visible:=False;
  LPrompt.Visible:=False;
  InpName.Visible:=False;
  LDummy.Visible:=True;
  RedrawAll;
  SelectLine(-1);
  Show;
  ActiveControl:=OKbtn;
end;

procedure TScoreForm.Execute(GTime:integer);
begin
  FindScore(GTime);
  if ActiveNo=0 then exit;
  ChangeMode:=True;
  InsertScore(ActiveNo);
  Scores[ActiveNo].Name:=PlayerName;
  Scores[ActiveNo].Time:=GTime;
  Scores[ActiveNo].Date:=Now;
  LDummy.Visible:=False;
  LGrat.Visible:=True;
  LPrompt.Visible:=True;
  InpName.Visible:=True;
  RedrawAll;
  SelectLine(ActiveNo);
  Show;
  ActiveControl:=InpName;
end;

procedure TScoreForm.OKbtnClick(Sender: TObject);
begin
  Close;
end;

procedure TScoreForm.FormCreate(Sender: TObject);
var i:integer;
begin
  ChangeMode:=False;
  with ScoreBox do begin
    ColWidths[0]:=30;Cells[0,0]:='Nr.';
    ColWidths[1]:=125;Cells[1,0]:='Name';
    ColWidths[2]:=50;Cells[2,0]:='Zeit';
    ColWidths[3]:=80;Cells[3,0]:='Datum';
    Cells[1,1]:='KeyJ BlackHole';Cells[2,1]:='02:30';Cells[3,1]:='28.03.2000';
    for i:=1 to 10 do Cells[0,i]:=IntToStr(i);
  end;
  LPrompt.Caption:='Sie haben eine der'#13'10 besten Zeiten'#13+
                   'erreicht. Bitte'#13'geben Sie ihren'#13+
                    'Namen ein, um in'#13'die Liste aufge-'#13+
                    'nommen zu werden:';
  InpName.Text:=PlayerName;
  ActiveNo:=0;
end;

procedure TScoreForm.InpNameChange(Sender: TObject);
var MrShy:boolean;
begin
  if not ChangeMode then exit;
  PlayerName:=InpName.Text;
  MrShy:=(PlayerName='');
  if MrShy then PlayerName:='Mr. Shy';
  Scores[ActiveNo].Name:=PlayerName;
  ScoreBox.Cells[1,ActiveNo]:=PlayerName;
  if not MrShy then
    InpName.Text:=PlayerName;
end;

end.
